import tkinter as tk
import pyautogui
import keyboard
import random
from PIL import ImageGrab, Image, ImageTk
import time as ttt
import threading
import time

class MacroLoopApp:
    def __init__(self, root):
        self.root = root

        # 무한 루프 동작 여부를 나타내는 플래그
        self.is_running = False

        self.seat_axis = []
        self.seat_class = set()
        self.time_axis = []
        self.pay_axis = []
        self.floor_axis = []
        self.need_seat_cnt = 2  # 연석인 경우 2 로 근데 잘 될지 모르겠음

        # 버튼 생성
        self.play_button1 = tk.Button(self.root, text="1층 매크로 시작", command=self.start_first_floor)
        self.play_button1.place(x=700, y=120)

        # 버튼 생성
        self.play_button2 = tk.Button(self.root, text="2/3층 매크로 시작", command=self.start_second_floor)
        self.play_button2.place(x=700, y=150)

        self.pause_button = tk.Button(self.root, text="매크로 중지", command=self.stop_infinite_loop)
        self.pause_button.place(x=700, y=180)

        self.canvas = tk.Canvas(self.root, width=500, height=500)
        self.canvas.place(x=100, y=100)

        # 버튼 생성
        self.button1 = tk.Button(self.root, text="좌석 영역 선택하기", command=self.get_axis)
        self.button1.place(x=700, y=460)

        self.button1 = tk.Button(self.root, text="2/3층 영역 선택하기", command=self.get_floor_axis)
        self.button1.place(x=700, y=490)

        self.button2 = tk.Button(self.root, text="좌석 등급 선택하기", command=self.get_color)
        self.button2.place(x=700, y=520)

        self.button3 = tk.Button(self.root, text="시간 선택 좌표 가져오기", command=self.get_time)
        self.button3.place(x=700, y=550)

        self.button4 = tk.Button(self.root, text="좌석 선택 완료 좌표 가져오기", command=self.select_axis)
        self.button4.place(x=700, y=580)

        self.color_listbox = tk.Listbox(self.root)
        self.color_listbox.place(x=700, y=280)
        self.color_listbox.bind("<ButtonRelease-1>", self.on_listbox_click)

        # 캔버스 생성
        self.color_canvas = tk.Canvas(self.root, width=50, height=30, bg="white")
        self.color_canvas.place(x=700, y=230)

    def start_first_floor(self):
        # 이미 무한 루프가 실행 중인 경우 중복 실행 방지
        if not self.is_running:
            self.is_running = True
            # 무한 루프를 새로운 스레드에서 실행
            threading.Thread(target=self.first_loop).start()

    def start_second_floor(self):
        # 이미 무한 루프가 실행 중인 경우 중복 실행 방지
        if not self.is_running:
            self.is_running = True
            # 무한 루프를 새로운 스레드에서 실행
            threading.Thread(target=self.second_loop).start()

    def stop_infinite_loop(self):
        # 무한 루프 동작을 멈추도록 플래그 설정
        self.is_running = False

    def first_loop(self):
        # 무한 루프
        while self.is_running:
            try:
                print(f"1층 매크로 실행중")
                self.same_rutine()
                time.sleep(2)
                self.search_seat()
            except:
                self.is_running = False
                print("error 발생")
                return

        print("Infinite Loop stopped.")

    def second_loop(self):
        # 무한 루프
        while self.is_running:
            try:
                print(f"2층 매크로 실행중")
                self.same_rutine()
                time.sleep(2)
                self.go_other_floor()
                time.sleep(1)
                self.search_seat()
            except:
                self.is_running = False
                print("error 발생")
                return

        print("Infinite Loop stopped.")

    def get_axis(self):
        while True:
            if keyboard.read_key() == "a":
                left_top = pyautogui.position()
                break

        while True:
            if keyboard.read_key() == "b":
                right_bottom = pyautogui.position()
                break

        self.seat_axis = [left_top, right_bottom]
        print(self.seat_axis)

        self.capture_region(left_top, right_bottom)
        return

    def get_floor_axis(self):
        while True:
            if keyboard.read_key() == "a":
                self.floor_axis = pyautogui.position()
                break
        return

    def capture_region(self, left_top, right_bottom):
        # 캡처하고자 하는 영역 캡처
        captured_image = ImageGrab.grab(bbox=(left_top[0], left_top[1], right_bottom[0], right_bottom[1]))
        captured_image = captured_image.resize((500, 500))

        # Tkinter PhotoImage로 변환
        tk_image = ImageTk.PhotoImage(captured_image)

        # Canvas를 사용하여 이미지 표시
        self.canvas.delete("all")  # 기존에 표시된 이미지 삭제
        self.canvas.create_image(0, 0, anchor=tk.NW, image=tk_image)

        # Canvas 크기 조절
        self.canvas.image_names = tk_image

    def update_listbox(self):
        # 리스트 박스 업데이트
        self.color_listbox.delete(0, tk.END)
        for color in self.seat_class:
            self.color_listbox.insert(tk.END, color)
        return

    def on_listbox_click(self, event):
        selected_index = self.color_listbox.curselection()

        if selected_index:
            selected_color = self.color_listbox.get(selected_index)
            print(f"Selected Color: {selected_color}")
            self.draw_color_rectangle(selected_color)
        return

    def draw_color_rectangle(self, rgb_values):
        # 캔버스 초기화
        self.color_canvas.delete("all")
        # RGB 값을 캔버스에 적용하여 사각형 그리기
        color_hex = "#{:02X}{:02X}{:02X}".format(rgb_values[0], rgb_values[1], rgb_values[2])
        self.color_canvas.create_rectangle(0, 0, 50, 50, fill=color_hex)
        return

    def get_color(self):
        my_class_list = []
        screen = ImageGrab.grab()
        while True:
            if keyboard.read_key() == "a":
                x, y = pyautogui.position()
                rgb = screen.getpixel((x, y))
                my_class_list.append(rgb)
            if keyboard.read_key() == "c":
                self.seat_class = set(my_class_list)
                self.update_listbox()
                break
        return

    def get_time(self):
        while True:
            if keyboard.read_key() == "a":
                self.time_axis = pyautogui.position()
                break

    def select_axis(self):
        while True:
            if keyboard.read_key() == "a":
                self.pay_axis = pyautogui.position()
                break

    def click(self, x, y):
        pyautogui.click(x, y)
        return

    def double_click(self, x, y):
        pyautogui.click(x, y)
        pyautogui.click(x, y)
        return

    def just_move(self, x, y):
        pyautogui.moveTo(x, y)
        return

    def press_up(self):
        pyautogui.press('up')
        return

    def press_down(self):
        pyautogui.press('down')
        return

    def go_other_floor(self):
        self.click(self.floor_axis[0], self.floor_axis[1])
        return

    def same_rutine(self):
        self.double_click(self.time_axis[0], self.time_axis[1])
        self.press_up()
        ttt.sleep(0.5)
        self.press_down()
        return

    def search_seat(self):
        delta_error = 10
        screen = ImageGrab.grab()

        for j in range(self.seat_axis[0][1], self.seat_axis[1][1], 7):
            for i in range(self.seat_axis[0][0], self.seat_axis[1][0], 7):
                # self.just_move(i,j)
                rgb = screen.getpixel((i, j))
                for r, g, b in self.seat_class:
                    if abs(rgb[0]-r) <= delta_error and abs(rgb[1] - g) <= delta_error and abs(rgb[2] - b) <= delta_error:
                        if self.need_seat_cnt == 2:
                            rgb2 = screen.getpixel((i+10, j))
                            for r2, g2, b2 in self.seat_class:
                                if abs(rgb2[0] - r2) <= delta_error and abs(rgb2[1] - g2) <= delta_error and abs(rgb2[2] - b2) <= delta_error:
                                    self.click(i, j)
                                    self.click(i+10, j)
                                    self.click(self.pay_axis[0], self.pay_axis[1])
                                    self.is_running = False
                                    return

                        elif self.need_seat_cnt == 1:
                            self.click(i, j)
                            self.click(self.pay_axis[0], self.pay_axis[1])
                            self.is_running = False
                            return
        return



if __name__ == "__main__":
    root = tk.Tk()
    root.title("please win this war..")
    # 윈도우 크기 고정
    root.geometry("900x700")
    # 윈도우 실행

    app = MacroLoopApp(root)
    root.mainloop()